package Allegory.Star;

import PrologDB.Tuple;
import PrologDB.ErrorReport;
import java.util.function.Function;
import Meta4Framework.TuPle;

public class wc extends TuPle<Database> {
    @Override
    public String TupleTypeName() { return "wc"; }

    public <TABLE> TABLE applywc(Function<wc,TABLE> f) { return f.apply(this); }

    public W cw;
    protected String _cw;  // needed by database loader
    public C wc;
    protected String _wc;  // needed by database loader

    public wc(String id, W cw, C wc) {
       this.id = id;
       this.cw = cw;
       this.wc = wc;
    }

    // constructors used in database loading
    protected wc() {}

    public wc(String id) {
       this.id = id;
       this.cw = null;
       this.wc = null;
    }

    private wc initFields(Tuple t) {
       id = t.get("id");
       _cw = t.get("cw");
       _wc = t.get("wc");
       return this;
    }

    public static wc make(Tuple t) {
       return new wc().initFields(t);
    }

    @Override
    public void finishTuple(Database db, ErrorReport er) {
       if(!_cw.equals("null"))
           cw = db.W.getTuple(_cw,er);
       if(!_wc.equals("null"))
           wc = db.C.getTuple(_wc,er);
    }
    // end of methods used for loading a database

    static final String fmt = "wc(%s,%s,%s).\n";

    @Override
    public String toString() {
       return String.format(fmt,id,__(cw),__(wc));
    }

    @Override
    public String toString(String fmt) {
       return String.format(fmt,id,__(cw),__(wc));
    }

}
