package Allegory.Star;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Allegory.Star.Lang.*;

public class zcTable extends TaBle<Database,zc,zcTable> {
    @Override
    public String TupleTypeName() { return "zc"; }

    public <TABLE> TABLE applyzc(Function<zcTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public zcTable(Database db) {
        this(db,null);
    }

    public zcTable(Database db, zc t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static zcTable BaseRelation(Database db) {
        zcTable tab = new zcTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<zc> tuples() {
        return tuples;
    }

    @Override
    public zcTable New() { return new zcTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       zc r = new zc(t.get("id"));
       r._cz = t.get("cz");
       r._zc = t.get("zc");
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(zc t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(zc t) {
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(zc,[id,cz:Z,zc:C]).");
    }

    @Override
    public String pformat() { return zc.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0, f2=0;
       for (zc a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,a.cz.id.length());
          f2 = Math.max(f2,a.zc.id.length());
       }
       return String.format("zc(!%ds,!%ds,!%ds).\n",f0,f1,f2).replace("!","%");
    }

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

   /* the following methods cast a subtable into a supertable */

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
